#!/bin/sh

# Simple testing framework for running the GRC dismantler

STRLXML=./strlxml
EXPANDMOD=./cec-expandmodules
DISMANTLE=./cec-dismantle
EXPAND=./cec-expandmodules
ASTGRC=./cec-astgrc

globallog=testgrc.log
rm -f $globallog
error=0

check_args(){
    if [ "x$1" = "xpdf" ]; then rundot=1; fi
    if [ "x$1" = "xopt" ]; then opt=1; fi
    if [ "x$1" = "xpdg" ]; then pdg=1; opt=1; fi
    if [ "x$1" = "xhw" ];  then extragrc=1; fi
}

Check() {
    basename=`echo $1 | sed 's/.*\\///
                             s/.strl//'`
    xmlfile=${basename}.xml
    expfile=${basename}.expand.xml
    disfile=${basename}.dis
    grcfile=${basename}.grc

    echo -n "Generating GRC for $basename..."
    echo "Generating GRC for $basename" 1>&2
    $STRLXML < $1 > $xmlfile 2>&1 || {
	echo "FAILED: strlxml terminated"
        error=1
	return 1
    }
    $EXPAND < $xmlfile > $expfile || {
        echo "FAILED: cec-expandmodules terminated"
        error=1
        return 1
    }
   $DISMANTLE < $expfile > $disfile || {
	echo "FAILED: cec-dismantle terminated"
        error=1
	return 1
    }
    $ASTGRC $extragrc < $disfile > $grcfile || {
	echo "FAILED: cec-astgrc terminated"
        error=1
	return 1
    }
    echo OK   
}

if expr $# > 1; then
  for file in "$@"
  do
    Check $file 2>> $globallog
  done
else
  for file in tests/test*.strl
  do
    Check $file 2>> $globallog
  done
fi

exit $error
